package microbasic.basic;

import java.util.*;
import microbasic.forms.RunForm;
import microbasic.misc.*;

public class Equation {
    public int solve(String eq) throws Exception {
        string_to_object(eq);
        Vector vec = new Vector();
        for (int x = 0; x != equation.length; x++) {
            vec.addElement(equation[x]);
        }
        Vector p_db = parenthesis_database();
        /* Rozwiazuje nawiasy */
        Enumeration en = p_db.elements();
        while (en.hasMoreElements()) {
            Object[] element = (Object[]) en.nextElement();
            int start_index, end_index;
            Vector meq = new Vector();
            start_index = vec.indexOf(element[0]);
            end_index = vec.indexOf(element[1]);
            for (int x = 1; x < (end_index - start_index); x++) {
                meq.addElement(vec.elementAt(start_index + 1));
                vec.removeElementAt(start_index + 1);
            }
            vec.removeElementAt(start_index + 1);
            vec.setElementAt(new Integer(process(meq)), start_index);
        }
        return process(vec);
    }

    /* Tworzy tablice odnosnikow do nawiasow Vector */
    private Vector parenthesis_database() {
        Vector db = new Vector();
        int equation_iter = 0;
        int level = 0;
        int left_start = 0;

        Object left = null, right = null;
        while (equation_iter != equation.length) {
            if (!(equation[equation_iter] instanceof CharacterBox)) {
                equation_iter++;
                continue;
            }
            CharacterBox ch = (CharacterBox) equation[equation_iter];
            if (ch.getCharacter().charValue() == '(') {
                if (left == null) {
                    left = equation[equation_iter];
                    left_start = equation_iter;
                    level = 0;
                    right = null;
                } else {
                    level++;
                }
            } else if (ch.getCharacter().charValue() == ')') {
                if (left == null) {
                    ; // Skip
                } else if (level == 0) {
                    right = equation[equation_iter];
                    // Jest wiec wpycham do tablicy nawiasiow
                    db.addElement(new Object[] {left, right,
                                  new Integer(equation_iter - left_start)});
                    // Wroc na poczatek
                    equation_iter = left_start;
                    // Jedna para jest, teraz wyzerowuje
                    left = null;
                    right = null;
                    level = 0;
                } else if (level > 0) {
                    level--;
                }
            }
            equation_iter++;
        }
        // Sortuje
        boolean change = true;
        while (change) {
            change = false;
            for (int x = 1; x < db.size(); x++) {
                Object first, second;
                int first_v, second_v;
                second_v = ((Integer) ((Object[]) db.elementAt(x))[2]).intValue();
                first_v = ((Integer) ((Object[]) db.elementAt(x - 1))[2]).
                          intValue();
                if (first_v > second_v) { // Swap
                    first = db.elementAt(x - 1);
                    second = db.elementAt(x);
                    db.setElementAt(second, x - 1);
                    db.setElementAt(first, x);
                    change = true;
                }
            }
        }
        return db;
    }

    /* Zamienia tekst na tablice obiektow Character oraz Integer */
    private void string_to_object(String eq) throws Exception {
        Vector vec = new Vector();
        char[] znaki = eq.toCharArray();
        String ops = "()*/+-";
        int mark = -1;
        for (int x = 0; x != znaki.length; x++) {
            if (!Character.isDigit(znaki[x]) &&
                ops.indexOf((int) znaki[x]) != -1) {
                if (mark != -1) {
                    if (Character.isDigit(znaki[mark])) {
                        vec.addElement(Integer.valueOf(eq.substring(mark, x)));
                    } else {
                        String var = eq.substring(mark, x);
                        if (var.indexOf('%') == -1) {
                            if (var.endsWith("$")) {
                                throw new Exception("Bad type in equation (" +
                                        var +
                                        ")");
                            }
                            vec.addElement((Integer) Memory.getVariable(var));
                        } else { //FUNC
                            vec.addElement((Integer) run_func(var));
                        }
                    }
                }
                vec.addElement(new CharacterBox(new Character(znaki[x])));
                mark = -1;
            } else {
                if (mark == -1) {
                    mark = x;
                }
            }

        }
        if (mark != -1) {
            if (Character.isDigit(znaki[mark])) {
                vec.addElement(Integer.valueOf(eq.substring(mark, znaki.length)));
            } else {
                String var = eq.substring(mark, znaki.length);
                if (var.indexOf('%') == -1) {
                    if (var.endsWith("$")) {
                        throw new Exception("Bad type in equation (" + var +
                                            ")");
                    }
                    vec.addElement((Integer) Memory.getVariable(var));
                } else { //FUNC
                    vec.addElement((Integer) run_func(var));
                }
            }
        }
        equation = new Object[vec.size()];
        vec.copyInto(equation);
    }

    /* To chyba nie trzeba tlumaczyc :) */
    private int operation(char op, int left, int right) {
        if (op == '*') {
            return left * right;
        } else if (op == '/') {
            return left / right;
        } else if (op == '+') {
            return left + right;
        } else if (op == '-') {
            return left - right;
        }

        return 0;
    }

    /* Rozwiazuje rownanie bez nawiasow */
    private int process(Vector eq_table) throws Exception {
        try {
            int symbol = 0;
            Enumeration en = eq_table.elements();
            int ret;
            while (eq_table.size() > 1) {
                char ch;
                Object elem;
                while (en.hasMoreElements()) {
                    elem = en.nextElement();
                    if (elem instanceof CharacterBox) {
                        ch = ((CharacterBox) elem).getCharacter().charValue();
                        if (ch == symbols[symbol] || ch == symbols[symbol + 1]) {
                            int iter = eq_table.indexOf(elem);
                            int result = operation(ch,
                                    ((Integer) eq_table.elementAt(
                                            iter -
                                            1)).
                                    intValue(),
                                    ((Integer) eq_table.elementAt(
                                            iter +
                                            1)).
                                    intValue());

                            eq_table.removeElementAt(iter - 1);
                            eq_table.removeElementAt(iter - 1);
                            eq_table.setElementAt(new Integer(result), iter - 1);
                            en = eq_table.elements();
                        }
                    }
                }
                en = eq_table.elements();
                symbol += 2;
            }
            ret = ((Integer) eq_table.firstElement()).intValue();
            return ret;
        } catch (Exception e) {
            throw new Exception("Parse error!");
        }
    }

    public static String solve_string_equation(String eq) throws Exception {
        Vector objs = new Vector();
        String ret = "";
        StringIterator plusiter = new StringIterator("+", eq);
        String tmp = "";
        String to_add;
        while (plusiter.hasMoreTokens()) {
            to_add = plusiter.nextToken();
            if (to_add.charAt(to_add.length() - 1) == '\\') {
                tmp += to_add.substring(0, to_add.length()-1) + "+";
                continue;
            } else if (!tmp.equals("")) {
                tmp += to_add;
            }
            if (tmp.equals("")) {
                objs.addElement(to_add);
            } else {
                objs.addElement(tmp);
                tmp = "";
            }
        }

        Enumeration en = objs.elements();
        while (en.hasMoreElements()) {
            String elem = (String) en.nextElement();
            if (elem.length() == 0) {
                throw new Exception("Parse error!");
            }
            // Zmienna
            if (elem.charAt(0) != '\"' && elem.indexOf('%') != -1) { //Func
                Object func_ret = run_func(elem);
                if (func_ret instanceof Integer) {
                    ret +=
                            Integer.toString(((Integer) func_ret).
                                             intValue());

                } else {
                    ret += (String) func_ret;
                }
            } else if (elem.indexOf('$') != -1) {
                ret += Memory.getVariable(elem);
            } else if (elem.charAt(0) == '\"' &&
                       elem.charAt(elem.length() - 1) == '\"') {
                ret += elem.substring(1, elem.length() - 1);
            } else {
                ret +=
                        Integer.toString(((Integer) Memory.getVariable(elem)).
                                         intValue());
            }
        }

        return ret;
    }

    // Dodatkowe funkcje

    static Object run_func(String line) throws Exception {
        int space = line.indexOf(' ');
        String comm = (space != -1) ? line.substring(0, space) : line;
        String arg = (space != -1) ? line.substring(space + 1).trim() :
                     "";
        if (comm.equals("%left$")) {
            return lefts(arg);
        } else if (comm.equals("%right$")) {
            return rights(arg);
        } else if (comm.equals("%mid$")) {
            return mids(arg);
        } else if (comm.equals("%chr$")) {
            return chrs(arg);
        } else if (comm.equals("%len")) {
            return len(arg);
        } else if (comm.equals("%asc")) {
            return asc(arg);
        } else if (comm.equals("%rand")) {
            return rand(arg);
        } else if (comm.equals("%getkey")) {
            return getkey();
        }

        return null;
    }

    // Numeryczne

    static Integer getkey() throws Exception {
        Integer ret = RunForm.getKey();
        if (ret == null) {
            return new Integer( -1);
        } else {
            return ret;
        }
    }

    static Integer len(String arg) throws Exception {
        return new Integer(solve_string_equation(arg).
                           length());
    }

    static Integer asc(String arg) throws Exception {
        return new Integer(solve_string_equation(arg).charAt(0));
    }

    static Integer rand(String arg) throws Exception {
        java.util.Random random = new java.util.Random();
        int num;
        int iarg;
        if (arg.length() != 0) {
            iarg = (new Equation()).solve(arg);
        } else {
            iarg = 0;
        }
        if (iarg == 0) {
            num = random.nextInt();
            if (num < 0) {
                num *= -1;
            }
        } else {
            num = random.nextInt() % iarg;
            if (num < 0) {
                num *= -1;
            }
        }
        return new Integer(num);
    }

    // String

    static String lefts(String arg) throws Exception {
        StringIterator iter = new StringIterator(",", arg);
        String var = Equation.solve_string_equation(iter.nextToken());
        int chars = (new Equation()).solve(iter.nextToken());
        if (chars == 0) {
            return var;
        }
        return var.substring(0, chars);
    }

    static String rights(String arg) throws Exception {
        StringIterator iter = new StringIterator(",", arg);
        String var = Equation.solve_string_equation(iter.nextToken());
        int chars = (new Equation()).solve(iter.nextToken());
        return var.substring(var.length() - chars);
    }

    static String mids(String arg) throws Exception {
        StringIterator iter = new StringIterator(",", arg);
        String var = Equation.solve_string_equation(iter.nextToken());
        int start = (new Equation()).solve(iter.nextToken());
        int chars = (new Equation()).solve(iter.nextToken());
        return var.substring(start,
                             start + chars);
    }

    static String chrs(String arg) throws Exception {
        int code = (new Equation()).solve(arg);
        return new String(new char[] {
                          (char) code
        });
    }

    private Object[] equation;
    final private char[] symbols = {'*', '/', '+', '-'};
}
