package microbasic.basic;

import java.util.*;

public class Memory {
    static public void alloc(String varname) throws Exception {
        if (varname.endsWith("$")) {
            if (varname.indexOf('[') == -1) {
                memdata.put(varname, new String());
            } else { // tab
                String name = varname.substring(0, varname.indexOf('['));
                String size_eq = varname.substring(varname.indexOf('[') + 1,
                        varname.indexOf(']'));
                int size = (new Equation()).solve(size_eq);
                for (int x = 0; x != size; x++) {
                    memdata.put(name + "[" + x + "]$", new String());
                }
            }
        } else {
            if (varname.indexOf('[') == -1) {
                memdata.put(varname, new Integer(0));
            } else { // tab
                String name = varname.substring(0, varname.indexOf('['));
                String size_eq = varname.substring(varname.indexOf('[') + 1,
                        varname.indexOf(']'));
                int size = (new Equation()).solve(size_eq);
                for (int x = 0; x != size; x++) {
                    memdata.put(name + "[" + x + "]", new Integer(0));
                }
            }
        }
    }

    static public void clear() {
        memdata.clear();
    }

    static public Object getVariable(String varname) throws Exception {
        Object ret = null;
        if (varname.indexOf('[') != -1) { // Tab
            String name = varname.substring(0, varname.indexOf('['));
            String index_eq = varname.substring(varname.indexOf('[') + 1,
                                                varname.indexOf(']'));
            int index = (new Equation()).solve(index_eq);
            String end = "";
            if (varname.charAt(varname.length() - 1) == '$') {
                end = "$";
            }
            ret = memdata.get(((String) name + "[" + index + "]" + end));
        } else {
            ret = memdata.get(varname);
        }
        if (ret == null) {
            throw new Exception("No such variable \'" + varname + "\'!");
        } else {
            return ret;
        }
    }

    static public void setVariable(String _varname, Object data) throws
            Exception {
        String varname=null;
        if (_varname.indexOf('[') != -1) { // Tab
            String name = _varname.substring(0, _varname.indexOf('['));
            String index_eq = _varname.substring(_varname.indexOf('[') + 1,
                                                _varname.indexOf(']'));
            int index = (new Equation()).solve(index_eq);
            String end = "";
            if (_varname.charAt(_varname.length() - 1) == '$') {
                end = "$";
            }
            varname = name + "[" + index + "]" + end;
        } else {
            varname=_varname;
        }
        if (memdata.containsKey(varname)) {
            if (((varname.endsWith("$")) && (data instanceof String)) ||
                ((!varname.endsWith("$")) &&
                 (data instanceof Integer))) {
                memdata.put(varname, data);
            } else {
                throw new Exception("Bad variable type!");
            }
        } else {
            throw new Exception("No such variable \'" + varname + "\'!");
        }
    }

    private static Hashtable memdata = new Hashtable();
}
