package microbasic.forms;

import javax.microedition.lcdui.*;

import microbasic.*;

public class CodeForm extends TextBox implements CommandListener {
    public CodeForm() {
        super("Code Editor", null, 2048, TextField.ANY);
        instance = (Displayable)this;
        addCommand(new Command("Newline", Command.SCREEN, 0));
        addCommand(new Command("Insert commas", Command.SCREEN, 1));
        addCommand(new Command("Run", Command.SCREEN, 2));
        addCommand(new Command("Save", Command.SCREEN, 3));
        addCommand(new Command("New", Command.SCREEN, 4));
        addCommand(new Command("Help", Command.SCREEN, 5));
        addCommand(new Command("Exit", Command.EXIT, 6));
        setCommandListener(this);
    }

    public void commandAction(Command command, Displayable displayable) {
        if (command.getCommandType() == Command.EXIT) {
            Display.getDisplay(MicroBasic.instance).setCurrent(MainForm.
                    instance);
        } else if (command.getCommandType() == Command.OK) {
        } else if (command.getCommandType() == Command.SCREEN) {
            if (command.getPriority() == 2) {
                RunForm runform = new RunForm(this.
                        getString());
                Display.getDisplay(MicroBasic.instance).setCurrent(runform.text);
            } else if (command.getPriority() == 3) {
                MainForm.previous = this;
                Display.getDisplay(MicroBasic.instance).setCurrent(new SaveForm(this.
                        getString()));
            } else if (command.getPriority() == 4) {
                this.setString("");
            } else if (command.getPriority() == 0) {
                this.insert("\n", this.getCaretPosition());
            } else if (command.getPriority() == 1) {
                this.insert("\"\";", this.getCaretPosition());
            } else if (command.getPriority() == 5) {
                MainForm.previous = (Displayable)this;
                Display.getDisplay(MicroBasic.instance).setCurrent(new HelpForm());
            }
        }
    }

    static public Displayable instance = null;
}

