package microbasic.forms;

import javax.microedition.lcdui.*;
import microbasic.misc.Downloader;
import microbasic.MicroBasic;

public class DownloadForm extends Form implements CommandListener {
    public DownloadForm() {
        super("Download file...");

        text = new TextField("Enter URL", "http://", 128, TextField.URL);
        downloading = false;
        saving = false;
        downloader = null;
        append(text);

        addCommand(new Command("OK", Command.OK, 0));
        addCommand(new Command("Exit", Command.EXIT, 1));
        setCommandListener(this);
    }

    public void downloaded() {
        this.delete(0);
        if(downloader.getDownloadedData()!=null) {
            SaveForm form = new SaveForm(downloader.getDownloadedData());
            Display.getDisplay(MicroBasic.instance).setCurrent(form);
        } else {
            this.append("Couldn't download!");
            saving = false;
            downloading = true;
        }
    }

    public void commandAction(Command command, Displayable displayable) {
        if(command.getCommandType()==Command.OK) {
            if(!downloading && !saving) { // okienko URL
                downloader = new Downloader(text.getString(), this);
                downloader.start();
                this.delete(0);
                this.append("Downloading ...");
                downloading = true;
            } else if(!downloading && saving) { //Okienko save
                // Zapisuje
                String name = text.getString();
                this.delete(0);
                this.append(name+"|"+downloader.getDownloadedData());
            }
        } else if(command.getCommandType()==Command.EXIT) {
            if(downloader!=null) downloader.interrupt();
            Display.getDisplay(MicroBasic.instance).setCurrent(MainForm.instance);
        }
    }

    private boolean downloading;
    private boolean saving;
    private Downloader downloader;
    private TextField text;
}
