package microbasic.forms;

import javax.microedition.lcdui.*;

public class HelpForm extends Form implements CommandListener {
    public HelpForm() {
        super("Help");
        append(text);
        addCommand(new Command("Text commands", Command.SCREEN, 0));
        addCommand(new Command("Graphic commands", Command.SCREEN, 1));
        addCommand(new Command("Integer operators", Command.SCREEN, 2));
        addCommand(new Command("String operators", Command.SCREEN, 3));
        addCommand(new Command("Exit", Command.EXIT, 4));
        setCommandListener(this);
    }

    public void commandAction(Command command, Displayable displayable) {
        if (command.getPriority() == 0) {
            text.setText("Reference:\n" +
                         "var name[[size]][$] - declares variable, optional argument size creates table.\n" +
                         "let name=[data] - imputes data to variable.\n" +
                         "print [data];[data]... - prints variables, semicolon links data.\n" +
                         "input [question];[var] - reads data to variable.\n" +
                         "clr - clears screen.\n" +
                         "if [exp] then [command] - if statement, example: if x>5 then print \"Is greater\".\n" +
                         "else [command] - extecutes [command] if previous if statement was false.\n" +
                         "mark [label] - marks position, use with goto.\n" +
                         "goto [label] - goes to previously marked position.\n" +
                         "for [var]=[val] to [end var] - imputes [val] to [var] and executes the loop until [var] is equal to [end var].\n" +
                         "next [var] - causes a iteration of [var] and proceeding in loop.\n" +
                         "gosub [label] - goes to previously marked subroutine.\n" +
                         "return - returns from subroutine.\n");
            text.setLabel("Text commands\n");
        } else if (command.getPriority() == 1) {
            text.setText("Reference:\n" +
                         "gclr - clears screen.\n" +
                         "rect x, y, width, height, fill, [color] - draws rectangle, if fill is not equal to 0 rectangle will be filled with color, color is numeric value.\n" +
                         "circle x, y, width, height, fill, [color] - draws circle, if fill is not equal to 0 circle will be filled with color, color is numeric value.\n" +
                         "line x1, y1, x2, y2, [color] - draws line\n." +
                         "poly x1, y1, x2, y2, x3, y3, fill, [color] - x, y, width, height, fill, [color] - draws polygon, if fill is not equal to 0 polygon will be filled with color, color is numeric value.\n" +
                         "gprint x, y, str$, [color] - prints str$ at x, y.\n\n" +
                         "Special variables:\ngwdt - screen width.\nghgt - screen height.\n");
            text.setLabel("Graphic commands\n");
        } else if (command.getPriority() == 2) {
            text.setText("Arithmetic operators:\n" +
                         "(, ), *, /, +, -.\n" +
                         "Special operators:\n" +
                         "%len [var] - returns length of [var].\n" +
                         "%asc [var] - returns ASCII code of first character in [var].\n" +
                         "%rand [var] - return random number from range from 0 to [var].\n" +
                         "%getkey - returns ASCII code of pressed key.\n");
            text.setLabel("Integer operators\n");
        } else if (command.getPriority() == 3) {
            text.setText("+, ; - connects strings.\n" +
                         "%left$ [var],[num] - returns leftmost [num] characters of [var].\n" +
                         "%right$ [var],[num] - returns rightmost [num] characters of [var].\n" +
                         "%mid$ [var],[start],[num] - Returns [num] characters of [var] starting at index [start].\n" +
                         "%chr$ [num] - returns ASCII character whose code is [num].\n");
            text.setLabel("String operators\n");
        } else if (command.getPriority() == 4) {
            Display.getDisplay(microbasic.MicroBasic.instance).setCurrent(
                    MainForm.
                    previous);
        }
    }

    private StringItem text = new StringItem("", "Choose chapter.");
}
