package microbasic.forms;

import javax.microedition.lcdui.*;
import microbasic.misc.Stock;
import java.io.*;

public class LoadForm extends Form implements CommandListener {
    public LoadForm() {
        super("Load file...");

        fs = new Stock("fs");
        fs.open();

        stock_size = fs.length();

        addCommand(new Command("Load", Command.SCREEN, 0));
        addCommand(new Command("Format", Command.SCREEN, 1));
        addCommand(new Command("Delete", Command.SCREEN, 2));
        addCommand(new Command("Exit", Command.EXIT, 3));
        setCommandListener(this);

        fillFilenames();
        append(files_item);
    }

    public synchronized void fillFilenames() {
        Image imgfile = null;
        try {
            imgfile = Image.createImage("/file.png");
        } catch (IOException ex) {
        }

        files_item = new ChoiceGroup("Files:", Choice.EXCLUSIVE);
        if (stock_size == 0) {
            return;
        }
        for (int x = 0; x < stock_size; x++) {
            String item = fs.get(x);
            try {
                item = item.substring(0, item.indexOf('|'));
                files_item.insert(files_item.size(), item, imgfile);
            } catch (Exception e) {
                System.err.println("Found invalid file! Deleting...");
                fs.delete(x);
                break;
            }
        }
    }

    public void commandAction(Command command, Displayable displayable) {
        if (command.getCommandType() == Command.SCREEN) {
            if (command.getPriority() == 0) { // Load
                String code = fs.get(files_item.getSelectedIndex());
                code = code.substring(code.indexOf('|') + 1);
                CodeForm form = new CodeForm();
                form.setString(code);
                fs.close();
                Display.getDisplay(microbasic.MicroBasic.instance).setCurrent(
                        form);
            } else if (command.getPriority() == 1) { // Format
                fs.delete();
                stock_size = 0;
                fs.close();
                Display.getDisplay(microbasic.MicroBasic.instance).setCurrent(
                        MainForm.
                        instance);

            } else if (command.getPriority() == 2) {
                if (stock_size == 0) {
                    return;
                }
                stock_size--;
                fs.delete(files_item.getSelectedIndex());
                fs.close();
                Display.getDisplay(microbasic.MicroBasic.instance).setCurrent(
                        MainForm.
                        instance);

            }
        } else if (command.getCommandType() == Command.EXIT) {
            fs.close();
            Display.getDisplay(microbasic.MicroBasic.instance).setCurrent(
                    MainForm.
                    instance);
        }
    }

    private int stock_size;
    private Stock fs;
    private ChoiceGroup files_item;
}
