package microbasic.forms;

import javax.microedition.lcdui.*;
import microbasic.MicroBasic;

public class MainForm extends Form implements CommandListener {
    public MainForm() {
        super("MicroBasic");
        append(new StringItem(null,
                              "MicroBasic 0.1\nCopyright (R) 2006 Szymon Ulewicz\n"));
        instance = this;
        addCommand(new Command("Exit", Command.EXIT, 0));
        addCommand(new Command("New", Command.SCREEN, 0));
        addCommand(new Command("Load", Command.SCREEN, 1));
        addCommand(new Command("Help", Command.HELP, 2));
        addCommand(new Command("Download", Command.SCREEN, 3));
        setCommandListener(this);
    }

    public void commandAction(Command command, Displayable displayable) {
        switch (command.getCommandType()) {
        case Command.EXIT:
            MicroBasic.instance.quitApp();
            break;
        case Command.SCREEN:
            if (command.getPriority() == 0) { // New
                Display.getDisplay(MicroBasic.instance).setCurrent(new CodeForm());
            } else if (command.getPriority() == 1) { // Load
                Display.getDisplay(MicroBasic.instance).setCurrent(new LoadForm());
            } else if (command.getPriority() == 3) {
                this.previous = this.instance;
                Display.getDisplay(MicroBasic.instance).setCurrent(new DownloadForm());
            }
            break;
        case Command.HELP:
            previous=this;
            Display.getDisplay(MicroBasic.instance).setCurrent(new HelpForm());
            break;
        }
    }

    public static Displayable previous = null;
    public static Form instance = null;
}
