package microbasic.misc;

import java.io.*;
import javax.microedition.io.*;
import microbasic.forms.DownloadForm;

public class Downloader extends Thread {

    public Downloader(String _url, DownloadForm _form) {
        url = _url;
        file = null;
        form = _form;
        interrupted = false;
    }

    public void run() {
        InputStreamReader in = null;
        try {
            in = new InputStreamReader(Connector.openInputStream(url));
            char[] buf = new char[256];
            file = new String();
            while (in.read(buf) != -1 && !interrupted) {
                file += new String(buf);
                buf = new char[256];
            }
            if(interrupted) throw new IOException();
        } catch (IOException ex) {
            file = null;
            form.downloaded();
        }
        form.downloaded();
    }

    public String getDownloadedData() {
        return file;
    }

    public void interrupt() {
        interrupted = true;
    }

    private String url;
    private String file;
    private boolean interrupted;
    private DownloadForm form;
}
