package microbasic.misc;

public class StringIterator {
    public StringIterator(String _frontier) {
        frontier = _frontier;
        text = "";
    }

    public StringIterator(String _frontier, String _text) {
        frontier = _frontier;
        text = _text;
        build_addr_table();
    }


    public void init(String _text) {
        text = _text;
        build_addr_table();
    }

    private void build_addr_table() {
        char[] chars = text.toCharArray();
        int length = 0;
        for (int x = 0; x != chars.length; x++) {
            if (frontier.indexOf((int) chars[x]) != -1) {
                length++;
            }
        }
        addr = new int[length + 2];
        addr[0] = 0;
        length = 1; // length staje sie zmiena pomocnicza, indeks w addr
        for (int x = 0; x != chars.length; x++) {
            if (frontier.indexOf((int) chars[x]) != -1) {
                addr[length] = x;
                length++;
            }
        }
        addr[length] = chars.length;

    }

    public boolean hasMoreTokens() {
        if (addr_index != (addr.length - 1)) {
            return true;
        } else {
            return false;
        }
    }

    public String nextToken() throws Exception {
        String ret;
        if (addr_index == (addr.length - 1)) {
            throw new Exception("There are no more tokens!");
        }
        ret = text.substring(addr[addr_index]+((addr_index!=0)?1:0), addr[addr_index + 1]);
        addr_index++;
        return ret;
    }

    private int addr_index = 0;
    private int[] addr = null;
    private String text;
    private String frontier;
}
